=== debian/changelog ===
cpprest (2.10.3-1) unstable; urgency=medium

  * New upstream version 2.10.3
  * Drop patch 787, boost-fix: upstream.
  * Refresh cmake-install patch
  * Drop sourcedirectory, now it has a cmake file in the root directory
  * Bump std-version to 4.2.0.1, no changes required

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 06 Aug 2018 09:55:26 +0200

cpprest (2.10.2-8) unstable; urgency=medium

  * cherry-pick upstream proposed patches:
    - Fix build with gcc-8 (Closes: #897730)
    - Fix build with boost 1.63

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 23 Jul 2018 13:07:42 +0200

cpprest (2.10.2-7) unstable; urgency=medium

  * debian/patches/{747,732}.patch: upstream fixes for clang related issues.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 25 May 2018 08:36:12 +0200
