## cpprest 2.10.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(cpprestsdk-root NONE)

add_subdirectory(Release)
