=== debian/changelog ===
cpprest (2.10.5-1) unstable; urgency=medium

  * New upstream version 2.10.5
  * Drop {732,fix-cmake-install}.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 18 Aug 2018 14:53:07 +0200
