## cpprest 2.10.6

=== Release/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 set(CPPREST_VERSION_MAJOR 2)
 set(CPPREST_VERSION_MINOR 10)
-set(CPPREST_VERSION_REVISION 4)
+set(CPPREST_VERSION_REVISION 6)
 
 enable_testing()
