=== debian/changelog ===
cpprest (2.10.6-1) unstable; urgency=medium

  * New upstream version 2.10.6
  * Drop patch 747, upstream

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 10 Sep 2018 17:51:21 +0200
